name: Tests

on:
  push:
    paths:
      - "**.go"
      - go.mod
      - go.sum
  pull_request:
    paths:
      - "**.go"
      - go.mod
      - go.sum

jobs:
  test:
    strategy:
      matrix:
        os: [ubuntu-latest, macos-latest, windows-latest]
        go: [1.21.x, 1.20.x] # when updating versions, update it below too.
    runs-on: ${{ matrix.os }}
    name: Test
    steps:

    - name: Set up Go ${{ matrix.node }}
      uses: actions/setup-go@v2
      with:
        go-version: ${{ matrix.go }}

    - name: Check out code
      uses: actions/checkout@v2

    - name: Download dependencies
      run: go mod download

    - name: Test
      # TODO(henvic): Skip generating code coverage when not sending it to Coveralls to speed up testing.
      continue-on-error: ${{ matrix.os != 'ubuntu-latest' || matrix.go != '1.21.x' }}
      run: go test -race -covermode atomic -coverprofile=profile.cov ./...

    - name: Code coverage
      if: ${{ matrix.os == 'ubuntu-latest' && matrix.go == '1.21.x' }}
      uses: shogo82148/actions-goveralls@v1
      with:
        path-to-profile: profile.cov
